program mynormal4
        version 18
        if replay() {
                if (`"`e(cmd)'"' != "mynormal4") error 301
                Replay `0'
        }
        else    Estimate `0'
end

program Estimate, eclass sortpreserve
        syntax varlist(fv) [if] [in] [,     ///
                vce(passthru)               ///
                noLOg                       /// <- NEW
                noCONStant                  /// <- NEW
                HETero(varlist fv)          ///
                *                           ///
        ]

        // check syntax
        mlopts mlopts other, `options'      //  <- NEW
        // parse Replay options
        _get_diopts diopts, `other'         // <- CHANGED
        gettoken lhs rhs : varlist
        _fv_check_depvar `lhs'
        // mark the estimation sample
        marksample touse
        markout `touse' `hetero'
        _vce_parse `touse', opt(Robust oim opg)     ///
                argopt(CLuster): , `vce'

        // fit the full model
        ml model lf2 mynormal_lf2                   ///
                (mu: `lhs' = `rhs', `constant')     /// <- CHANGED
                (lnsigma: `hetero')                 ///
                if `touse',                         ///
                `vce'                               ///
                `log'                               /// <- NEW
                `mlopts'                            /// <- NEW
                missing                             ///
                maximize

        ereturn local cmd mynormal4

        Replay , `diopts' 
end

program Replay
        syntax [, *]
        ml display , `options' 
end
