program myweibull_lf
	version 18
	args lnfj leta lgam
	tempvar p M R
	quietly {
		generate double `p' = exp(`lgam')
		generate double `M' = ($ML_y1*exp(-`leta'))^`p'
		generate double `R' = ln($ML_y1)-`leta'
		replace `lnfj' = -`M' + $ML_y2*(`lgam'-`leta'+(`p'-1)*`R')
	}
end
