program mynormal1
        version 18
        if replay() {
                if (`"`e(cmd)'"' != "mynormal1") error 301
                Replay `0'
        }
        else    Estimate `0'
end

program Estimate, eclass sortpreserve
        syntax varlist(fv) [if] [in] [,     ///
                vce(passthru)               ///
                *                           /// -Replay- options    
        ]

        // check syntax
        gettoken lhs rhs : varlist
        // parse Replay options
        _get_diopts diopts, `options'
        // mark the estimation sample
        marksample touse

        // fit the full model
        ml model lf2 mynormal_lf2           ///
                (mu: `lhs' = `rhs')         ///
                /lnsigma                    ///
                if `touse',                 ///
                `vce'                       ///
                maximize

        ereturn local cmd mynormal1

        Replay , `diopts' 
end

program Replay
        syntax [, *]
        ml display , `options' 
end
