program mynormal_lf1
        version 18
        args todo b lnfj g1 g2
        tempvar mu lnsigma sigma
        mleval `mu' = `b', eq(1)
        mleval `lnsigma' = `b', eq(2)
        quietly {
                generate double `sigma' = exp(`lnsigma')
                replace `lnfj' = ln( normalden($ML_y1,`mu',`sigma') )
                if (`todo'==0) exit

                tempvar z
                generate double `z' = ($ML_y1-`mu')/`sigma'
                replace `g1' = `z'/`sigma'
                replace `g2' = `z'*`z'-1
        }
end
